#include "stdafx.h"
#include "zlwcrypt.h"
#include "DropFeld.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////
// Dialogfeld CDropFeld 


CDropFeld::CDropFeld(CWnd* pParent /*=NULL*/)
	: CDialog(CDropFeld::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDropFeld)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CDropFeld::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDropFeld)
	DDX_Control(pDX, IDC_LOCK2, m_lock2);
	DDX_Control(pDX, IDC_LOCK1, m_lock1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDropFeld, CDialog)
	//{{AFX_MSG_MAP(CDropFeld)
	ON_WM_DROPFILES()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDropFeld 

BOOL CDropFeld::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//Datei Drop aktivieren
	DragAcceptFiles();

	//Immer als oberstes Fenster
	SetWindowPos(&this->wndTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	//Transparenz (Standard: 0xAA)
	HMODULE hDLL = LoadLibrary ("user32");
	PSLWA pSetLayeredWindowAttributes = (PSLWA) GetProcAddress(hDLL, "SetLayeredWindowAttributes");
	SetWindowLong(GetSafeHwnd(), GWL_EXSTYLE , GetWindowLong(GetSafeHwnd(), GWL_EXSTYLE) | WS_EX_LAYERED);
	pSetLayeredWindowAttributes (GetSafeHwnd(), RGB(255,255,255), 0xaa, LWA_ALPHA);

	return TRUE; 
}

// Symbol setzen
void CDropFeld::SymbolControl(UINT aktion)
{
	switch(aktion)
	{	
	case 1:
			m_lock1.ShowWindow(TRUE);
			m_lock2.ShowWindow(FALSE);
			break;

	case 2:  
			m_lock1.ShowWindow(FALSE);
			m_lock2.ShowWindow(TRUE);
			break;

	case 0:
			m_lock1.ShowWindow(FALSE);
			m_lock2.ShowWindow(FALSE);
			break;
	}
}

//Wenn Dateien gedroppt wurden
void CDropFeld::OnDropFiles(HDROP dateiinfo)
{
	SymbolControl(0);
	
	tagPOINT mausposi;
	DragQueryPoint(dateiinfo, &mausposi);
	
	CString sAktion = "", sObjektart = "", sSicherheitsabfrage = "";		
	char dateipfad[256];
	CFileFind PfadTest;
	
	UINT iDateiAnzahl = DragQueryFile(dateiinfo,0xFFFFFFFF,NULL,0);
	for (UINT i=0; i<iDateiAnzahl; i++)
	{
		DragQueryFile(dateiinfo,i,dateipfad,255);					
		PfadTest.FindFile((CString)dateipfad);
		PfadTest.FindNextFile();
		
		// Bestimmung der Aktion (verschlsseln oder entschlsseln)
		if (PfadTest.MatchesMask(FILE_ATTRIBUTE_ENCRYPTED) ) 
		{
			sAktion = "entschlsseln";
			SymbolControl(2);
		}
		
		else 
		{
			sAktion = "verschlsseln";
			SymbolControl(1);
		}
		
		// Bestimmung der Objektart (Ordner oder Datei)
		if (PfadTest.IsDirectory())
		{
			sObjektart = "Ordner";
			sSicherheitsabfrage = "Ordner \"" + (CString)dateipfad + "\" zum " + sAktion + " markieren ?";
		}
		else 
		{
			sObjektart = "Datei";
			sSicherheitsabfrage = "Datei \"" + (CString)dateipfad + "\" " + sAktion + " ?";
		}	
		
		// Sicherheitsabfrage bei jeder Datei
		if(MessageBox(sSicherheitsabfrage, "NTFS Verschlsselung", MB_YESNO|MB_ICONQUESTION) == IDYES) FileCrypt(sAktion, (CString)dateipfad);
		else 
		{
			sAktion = "";
			SymbolControl(0);
		}
		
	}	// FOR Schleife durch alle Dateien/Ordner zu Ende
	
	DragFinish(dateiinfo);
	PfadTest.Close();
}

//verschlsseln / Entschlsseln
void CDropFeld::FileCrypt(CString aktion, CString Pfad)
{
	CFileFind PfadTest;
	PfadTest.FindFile(Pfad);
	PfadTest.FindNextFile();

	// Ordner . und .. sind nicht zugelassen
	if (PfadTest.IsDirectory() && PfadTest.IsDots()) return;

	FILETIME LastWrite, LastAccess, Creation;
	PfadTest.GetLastWriteTime(&LastWrite);
	PfadTest.GetLastAccessTime(&LastAccess);
	PfadTest.GetCreationTime(&Creation);
	
	// Eigentliche NTFS Verschlsselung/Entschlsselung durchfhren
	BOOL bErgebnis;
	if (aktion == "entschlsseln") bErgebnis = DecryptFile(Pfad,0);
	else if (aktion == "verschlsseln") bErgebnis = EncryptFile(Pfad);

	// ins Statusfenster schreiben
	CString sErgebnis ="";
	bErgebnis == TRUE ? sErgebnis = "erfolgreich" : sErgebnis = "fehlgeschlagen";

	// gesicherte Dateiattribute wieder schreiben und runterscrollen
	HANDLE hFile = CreateFile( Pfad, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL );
	SetFileTime(hFile, &Creation, &LastAccess, &LastWrite);
	CloseHandle(hFile);	
}

//Doppelklick = Dialogwechsel
void CDropFeld::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	EndDialog(13371337);
	//CDialog::OnLButtonDblClk(nFlags, point);
}

//zum Fensterverschieben mit der Maus
void CDropFeld::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);

	PostMessage(WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM( point.x, point.y));
}
