#include "stdafx.h"
#include "zlwcrypt.h"
#include "zlwcryptDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CZlwcryptDlg::CZlwcryptDlg(CWnd* pParent)
	: CDialog(CZlwcryptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZlwcryptDlg)
	m_aktion = _T("");
	m_ordner = _T("");
	m_datei = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ZLW);
}

void CZlwcryptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZlwcryptDlg)
	DDX_Control(pDX, IDC_LOCK2, m_lock2);
	DDX_Control(pDX, IDC_LOCK1, m_lock1);
	DDX_Text(pDX, IDC_AKTION, m_aktion);
	DDX_Text(pDX, IDC_ORDNER, m_ordner);
	DDX_Text(pDX, IDC_DATEI, m_datei);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZlwcryptDlg, CDialog)
	//{{AFX_MSG_MAP(CZlwcryptDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CRYPT, OnButtonCrypt)
	ON_BN_CLICKED(IDC_BUTTON_DECRYPT, OnButtonDecrypt)
	ON_BN_CLICKED(IDC_BUTTON_NTFS, OnButtonCleanup)
	ON_WM_DROPFILES()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CZlwcryptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);


	//Eingabefelder initialisieren
	m_ordner = "D:\\daten";
	m_datei = "*.*";
	UpdateData(false);

	m_lock1.ShowWindow(FALSE);
	m_lock2.ShowWindow(FALSE);
	
	// Drag und Drop fr den ganzen Dialog aktivieren
	DragAcceptFiles();
	
	//Fenster immer im Vordergrund
	SetWindowPos(&this->wndTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	return TRUE;
}

void CZlwcryptDlg::OnPaint() 
{
	// MFC Geblah ...
	if (IsIconic())
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CZlwcryptDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CZlwcryptDlg::OnButtonCrypt() 
{
	ButtonControl(false);
	SymbolControl(1);

	DoAction("verschlsseln");

	ButtonControl(true);
}

void CZlwcryptDlg::OnButtonDecrypt() 
{
	ButtonControl(false);
	SymbolControl(2);

	DoAction("entschlsseln");

	ButtonControl(true);
}

void CZlwcryptDlg::OnDropFiles(HDROP dateiinfo)
{
	m_aktion="";
	UpdateData(FALSE);

	ButtonControl(false);
	SymbolControl(0);
	
	tagPOINT mausposi;
	DragQueryPoint(dateiinfo, &mausposi);
		
	if (mausposi.x > 40 && mausposi.x < 160 && mausposi.y > 245 && mausposi.y < 315)
	{
		CString sAktion = "", sObjektart = "", sSicherheitsabfrage = "";		
		char dateipfad[256];
		CFileFind PfadTest;

		UINT iDateiAnzahl = DragQueryFile(dateiinfo,0xFFFFFFFF,NULL,0);
		for (UINT i=0; i<iDateiAnzahl; i++)
		{
			DragQueryFile(dateiinfo,i,dateipfad,255);					
			PfadTest.FindFile((CString)dateipfad);
			PfadTest.FindNextFile();

			// Bestimmung der Aktion (verschlsseln oder entschlsseln)
			if (PfadTest.MatchesMask(FILE_ATTRIBUTE_ENCRYPTED) ) 
			{
				sAktion = "entschlsseln";
				SymbolControl(2);
			}
			
			else 
			{
				sAktion = "verschlsseln";
				SymbolControl(1);
			}

			// Bestimmung der Objektart (Ordner oder Datei)
			if (PfadTest.IsDirectory())
				{
				sObjektart = "Ordner";
				sSicherheitsabfrage = "Ordner \"" + (CString)dateipfad + "\" zum " + sAktion + " markieren ?";
				}
			else 
				{
				sObjektart = "Datei";
				sSicherheitsabfrage = "Datei \"" + (CString)dateipfad + "\" " + sAktion + " ?";
				}	
			
			// Sicherheitsabfrage bei jeder Datei
			if(MessageBox(sSicherheitsabfrage, "NTFS Verschlsselung", MB_YESNO|MB_ICONQUESTION) == IDYES) FileCrypt(sAktion, (CString)dateipfad);
			else 
			{
				sAktion = "";
				SymbolControl(0);
			}

		}	// FOR Schleife durch alle Dateien/Ordner zu Ende

		DragFinish(dateiinfo);
		PfadTest.Close();

		m_aktion += "\r\n--> fertig";
		UpdateData(FALSE);
		reinterpret_cast<CEdit *>(GetDlgItem(IDC_AKTION))->LineScroll(6);
		ButtonControl(true);

	}	//Grosse Mausposi-Test "If" zu Ende
}

void CZlwcryptDlg::FileCrypt(CString aktion, CString Pfad)
{
	CFileFind PfadTest;
	PfadTest.FindFile(Pfad);
	PfadTest.FindNextFile();

	// Ordner . und .. sind nicht zugelassen
	if (PfadTest.IsDirectory() && PfadTest.IsDots()) return;

	FILETIME LastWrite, LastAccess, Creation;
	PfadTest.GetLastWriteTime(&LastWrite);
	PfadTest.GetLastAccessTime(&LastAccess);
	PfadTest.GetCreationTime(&Creation);
	
	// Eigentliche NTFS Verschlsselung/Entschlsselung durchfhren
	BOOL bErgebnis;
	if (aktion == "entschlsseln") bErgebnis = DecryptFile(Pfad,0);
	else if (aktion == "verschlsseln") bErgebnis = EncryptFile(Pfad);

	// ins Statusfenster schreiben
	CString sErgebnis ="";
	bErgebnis == TRUE ? sErgebnis = "erfolgreich" : sErgebnis = "fehlgeschlagen";
	m_aktion += Pfad  + " --> \"" + aktion + "\" " + sErgebnis + "\r\n";
	UpdateData(FALSE);
	reinterpret_cast<CEdit *>(GetDlgItem(IDC_AKTION))->LineScroll(3);

	// gesicherte Dateiattribute wieder schreiben und runterscrollen
	HANDLE hFile = CreateFile( Pfad, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL );
	SetFileTime(hFile, &Creation, &LastAccess, &LastWrite);
	CloseHandle(hFile);	
}

void CZlwcryptDlg::OnButtonCleanup() 
{
	// Fhrt einfach nur Cipher.exe aus ...
	UpdateData(TRUE);
	m_aktion="";
	UpdateData(FALSE);
	SymbolControl(0);

	unsigned int comboindex = m_combobox1.GetCurSel();
	CString combostring;
	m_combobox1.GetLBText(comboindex, combostring);
	
	if(!DirCheck(combostring)) m_aktion = "FEHLER: Verzeichnis nicht gefunden";
	else 
	{
		HINSTANCE hStarttest = ShellExecute(0, "open", "Cipher.exe", "/W:" + combostring, "", SW_SHOWNORMAL);
		if ((int)hStarttest > 32)
		{
			m_aktion = "NTFS Cleanup auf den Ordner "+ combostring + " ausgefhrt ";
		}
		else {m_aktion = "Cipher nicht gefunden";}
	}
	UpdateData(FALSE);
}

void CZlwcryptDlg::DoAction(CString aktion)
{
	// Eingabefelder auslesen und Statusfenster reseten
	UpdateData(TRUE);
	m_aktion="";
	UpdateData(FALSE);
	
	// Fr Comboboxen
	/*unsigned int comboindex1 = m_combobox1.GetCurSel();
	unsigned int comboindex2 = m_combobox2.GetCurSel();
	CString combostring1 = "", combostring2 = "";
	m_combobox1.GetLBText(comboindex1, combostring1);
	m_combobox2.GetLBText(comboindex2, combostring2);*/

	CString combostring1 = m_ordner, combostring2 = m_datei;

	if (DirCheck(combostring1) == false)	//Abbruch, wenn Verzeichnis nicht existiert 
		{
		m_aktion = "\r\n-->FEHLER: Verzeichnis nicht gefunden, Abbruch";
		UpdateData(FALSE);
		return;
		}

	unsigned int iDateicounter = 0;
	char sDateicounter[32]; 
	MSG Msg;

	// Geht alle Dateien im Ordner nacheinander durch
	CFileFind Dateien;
	BOOL bGefunden = Dateien.FindFile(combostring1 + "\\" + combostring2);
	while (TRUE == bGefunden)
	{
		bGefunden = Dateien.FindNextFile();
		
		if (!Dateien.IsDirectory() && !Dateien.IsDots() && !Dateien.IsReadOnly() && !Dateien.IsSystem())
		{	
			// Fr's Statusfenster
			_itoa(iDateicounter++, sDateicounter, 10);
			CString Pfad = Dateien.GetFilePath();
			
			// Dateiattribute sichern
			FILETIME LastWrite, LastAccess, Creation;
			Dateien.GetLastWriteTime(&LastWrite);
			Dateien.GetLastAccessTime(&LastAccess);
			Dateien.GetCreationTime(&Creation);
			
			// Eigentliche NTFS Verschlsselung/Entschlsselung durchfhren
			BOOL bErgebnis;
			if (aktion == "entschlsseln") bErgebnis = DecryptFile(Pfad,0);
			else if (aktion == "verschlsseln") bErgebnis = EncryptFile(Pfad);
			
			// Damit das Statusfenster whrend der Schleife upgedated wird	
			BOOL IsMessage = ::PeekMessage( &Msg,NULL,0,0,PM_REMOVE);
			if (IsMessage) 
			{
				TranslateMessage(&Msg);
				DispatchMessage(&Msg);
			}
			
			// ins Statusfenster schreiben
			CString sErgebnis ="";
			bErgebnis == TRUE ? sErgebnis = "erfolgreich" : sErgebnis = "fehlgeschlagen";
			m_aktion += (CString)sDateicounter + " - " + Pfad  + " --> " + sErgebnis + "\r\n";
			UpdateData(FALSE);
			reinterpret_cast<CEdit *>(GetDlgItem(IDC_AKTION))->LineScroll(3);

			// gesicherte Dateiattribute wieder schreiben und runterscrollen
			HANDLE hFile = CreateFile( Pfad, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL );
			SetFileTime(hFile, &Creation, &LastAccess, &LastWrite);
			CloseHandle(hFile);	
		}
	}	// Ende while Schleife = durh alle Dateien durch

	m_aktion += "\r\n--> Aktion \"" + aktion + "\" abgeschlossen";
	UpdateData(FALSE);

	// Nochwas runterscrollen und Buttons wieder aktivieren
	reinterpret_cast<CEdit *>(GetDlgItem(IDC_AKTION))->LineScroll(6);
}

//Checkt, ob das angegebene Verzeichnis existiert
bool CZlwcryptDlg::DirCheck(CString dirstring)
{
	CFileFind verz;
	BOOL test = verz.FindFile(dirstring);

	if (verz.FindFile(dirstring) == TRUE) return true;
	else return false;
}

// Buttons aktivieren/deaktivieren
void CZlwcryptDlg::ButtonControl(bool aktion)
{
	reinterpret_cast<CButton *>(GetDlgItem(IDC_BUTTON_CRYPT))->EnableWindow(aktion);
	reinterpret_cast<CButton *>(GetDlgItem(IDC_BUTTON_DECRYPT))->EnableWindow(aktion);
	reinterpret_cast<CButton *>(GetDlgItem(IDC_BUTTON_NTFS))->EnableWindow(aktion);
}

// Symbol setzen
void CZlwcryptDlg::SymbolControl(UINT aktion)
{
	switch(aktion)
	{	
	case 1:
			m_lock1.ShowWindow(TRUE);
			m_lock2.ShowWindow(FALSE);
			break;

	case 2:  
			m_lock1.ShowWindow(FALSE);
			m_lock2.ShowWindow(TRUE);
			break;

	case 0:
			m_lock1.ShowWindow(FALSE);
			m_lock2.ShowWindow(FALSE);
			break;
	}
}

//Doppelklick = Dialogwechsel
void CZlwcryptDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	EndDialog(13371337);
	//CDialog::OnLButtonDblClk(nFlags, point);
}

//zum Fensterverschieben mit der Maus
void CZlwcryptDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);

	PostMessage(WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM( point.x, point.y));
}